﻿@page "/players"
@using Models
@using Models.PlayerData
@using Business.Repository.IRepository
@inject IPlayerRepository PlayerRepository
@inject IJSRuntime JsRuntime
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@inject NavigationManager NavigationManager

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Players</h4>
    </div>
    <div class="col-3 offset-1">
        <NavLink href="players/create" class="btn btn-primary form-control">Add new player</NavLink>
    </div>
</div>
<div class="row mt-4">
    <div class="col-12">
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th width="5%" class="text-center">#</th>
                    <th width="30%" class="text-center">Name</th>
                    <th width="20%" class="text-center">Sport</th>
                    <th width="10%">
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (Players.Any())
                {
                    int i = 1;
                    @foreach (var player in Players)
                    {
                        <tr>
                            <td class="text-center">@(i + (Pagination.Page - 1)*10)</td>
                            @{i++;}
                            <td class="text-center">@player.Name @player.Surname</td>
                            <td class="text-center">@player.Sport.Name</td>
                            <td>
                                <NavLink href="@($"players/edit/{player.Id}")" class="btn btn-primary">Edit</NavLink>
                                <button class="btn btn-danger" @onclick="() => HandleDelete(player.Id)">Delete</button>
                            </td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>


<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {
    private IEnumerable<PlayerDTO> Players { get; set; } = new List<PlayerDTO>();
    private int? DeletePlayerId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;
    public PaginationDTO Pagination { get; set; } = new PaginationDTO();

    public int SportId { get; set; }

    protected async override Task OnInitializedAsync()
    {
        SportId = await localStorage.GetItemAsync<int>("sportId");
        Players = await PlayerRepository.GetAllFromSport(SportId);
    }

    private async Task HandleDelete(int playerId)
    {
        DeletePlayerId = playerId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeletePlayerId != null)
        {
            await PlayerRepository.Delete(DeletePlayerId.Value);
            await JsRuntime.ToastrSuccess("Player deleted successfully!");
            Players = await PlayerRepository.GetAllFromSport(SportId);
            StateHasChanged();
        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
}
